/*______________________________________________________
-- Create default, index, and temporary  tablespaces 
   for user Gradebook.

   In Oracle 10g, 
     1. Create the subdirectory in which dababase files
	are to be held.
     2. Do not create dbf files. Otherwise syntax error
	will occur.
_______________________________________________________*/

CREATE USER hotel SUPERUSER PASSWORD 'c3m4p2s';  -- create a role.

CREATE TABLESPACE hotelData
	 OWNER hotel
	 LOCATION '/Users/postgres/dbs/hotel/data';    -- The directories should be created before in postgres user
 --      [ WITH ( tablespace_option = value [, ... ] ) ]
CREATE TABLESPACE hotelIdx
	 OWNER hotel
	 LOCATION '/Users/postgres/dbs/hotel/idx';     -- separate indexes from relations/tables
 --      [ WITH ( tablespace_option = value [, ... ] ) ]

CREATE DATABASE hotel WITH OWNER = hotel TABLESPACE = hotelData; 

