
CREATE TABLE IF NOT EXISTS hotel (
	hNo integer primary key not null,
	hName varchar(20) default 'Marriot',
	city  varchar(15) default 'Las Vegas'
); 


CREATE TABLE IF NOT EXISTS guest (
	gNo integer ,
	gName varchar(20) default 'John Doe',
	street varchar(30) default '123 Main Street',
	city   varchar(15) default 'Bakersfield',
	state  char(2)      default 'CA',
	zip    integer    default 93305,
        CONSTRAINT pk_guest PRIMARY KEY(gNo)
); 


CREATE TABLE IF NOT EXISTS room (
	hNo integer default 1 references hotel(hNo),
	rNo integer default 0,
	type varchar(10) default 'Single',
	price REAL default 75.99,
        CONSTRAINT pk_room PRIMARY KEY(hNo, rNo),
        CONSTRAINT ck_room_price CHECK( price >= 19.99 AND price <= 10000)
); 


CREATE TABLE IF NOT EXISTS book (
        -- id  SERIAL UNIQUE,
	gNo integer not null ,
	hNo integer not null ,
	rNo integer not null ,
	dateFrom Date not null ,
	dateTo   Date not null ,
        CONSTRAINT pk_4fieldskkk
	UNIQUE (gNo, hNo, rNo, dateFrom),
        -- CONSTRAINT pk_book PRIMARY KEY(id  ),
	CONSTRAINT fk_book_guest FOREIGN KEY (gNo)  REFERENCES guest(gNo),
	CONSTRAINT fk_book_hotel FOREIGN KEY (hNo)  REFERENCES hotel(hNo),
	CONSTRAINT fk_book_room FOREIGN KEY (hNo, rno)  REFERENCES room(hno, rno),
	CONSTRAINT ck_book_dates CHECK( dateTo > dateFrom )
) ;

create view VBook as select gname, hname, rno, dateFrom, DateTo, (DateTo - DateFrom) as Days
from (( hotel natural join room ) natural join   book ) A inner join guest B ON A.gno = b.gno ;



\i crt_procedures.sql
