/* List all hotels that has no guest coming back

  Tuple Relational Calculus Solution:
  { h | hotel(h) & 
       ( ForAll( b ) ( book(b) & b.hno = h.hno -> 
	                 NOT exists(b2) ( book(b2) & b2.gNo = b.gNo & b2.hno = b.hno & b2.dateFrom != b.dateFrom )
	             )
       )
  }

  After translated ForAll and Imply (->) operators, the query SQL is given below. 
*/


select unique h.hno
from hotel h
where NOT EXISTS (
   select * from book b 
   where b.hno = h.hNo and 
	exists ( select * from book b2
	         where b2.gno = b.gno and b2.hno = b.hno and b2.dateFrom != b.dateFrom 
    	)
    )
order by h.hno
